unit Share;

// ************************************************
//  , -     HiAsm
// Last modification: 09.06.2005
// ************************************************
{
   :
    ##array
    ##ReadXXX
    ##ToXXX
    ##_hi_onEvent
    ##_hi_CreateEvent
    ##_DoData
    ##CreateData
}

interface

uses Windows,Kol,WinSock;

{$include def.inc}
{$include share.inc}

{$ifdef F_P}
{$SMARTLINK ON}
{$endif}

const
  data_null   = 0;
  data_int    = 1;
  data_str    = 2;
//data_data   = 3;
//data_combo  = 4;
//data_list   = 5;
  data_icon   = 6;
  data_real   = 7;
//data_color  = 8;
//data_script = 9;
  data_stream = 10;
  data_bitmap = 11;
//data_wave   = 12;
  data_array  = 13;
//data_comboEx= 14;
  data_font   = 15;
  data_matr   = 16;
  data_jpeg   = 17;
  data_menu   = 18;
//data_code   = 19;
  data_object = 20;
  data_break  = 21; //!!!   

 data_gl_point3d = 100;
 data_rect = 101;

const
  crDefault   = 0;
  crArrow     = 1;
  crIBeam     = 19;
  crHourGlass = 21;
  crCross     = 23;
  crUpArrow   = 25;
  crSizeNWSE  = 27;
  crSizeNESW  = 29;
  crSizeWE    = 31;
  crSizeNS    = 33;
  crSizeAll   = 35;
  crNo        = 37;
  crBusy      = 39;
  crHelp      = 41;
  crPen       = 43;
  crHandPoint = 45;
  crCube      = 47;
  crCD        = 49;

  crSize = crSizeAll;
  crWait = crHourGlass;
//!!!    Debug   _Debug
  DataNames:array[0..21]of string =
   (
     'NULL',
     'Integer',
     'String',
     'Data',
     'Combo',
     'StrList',
     'Icon',
     'Real',
     'Color',
     'Script',
     'Stream',
     'Bitmap',
     'Wave',
     'Array',
     'ComboEx',
     'Font',
     'Matrix',
     'Jpeg',
     'Menu',
     'Code',
     'Object',
     'Break'
   );

type
  THiInt = integer;

  PHI_Event = ^THI_Event;

  //TGL_Point3D

  PData = ^TData;
  TData = record
    Data_type:byte;
    idata:THiInt;
    sdata:string;
    rdata:real;
    Next:PHI_Event;
    ldata:PData;
  end;
  PValue = ^TValue;
  TValue = record
    vtype:byte;
    vdata:pointer;
  end;
  TFontRec = record
     Name:string;
     Size:byte;
     Style:byte;
     Color:TColor;
     CharSet:byte;
  end;
  PFontRec = ^TFontRec;

  TRGB = record r,g,b,x:byte; end;

  TEvent = procedure(var Data:TData; Index:word) of object;
  THI_Event = record
    Event:TEvent;
    Index:word;
    {$ifdef _DEBUG_}
    dbgID,dbgIndex:Cardinal;
    {$endif}
  end;
  TInitProc = procedure of object; //!!!   InitMan

  TMatrSet = procedure(x,y:integer; var Val:TData) of object;
  TMatrGet = function(x,y:integer):TData of object;
  TMatrSize = function:integer of object;
  TMatrix = record
    _Set:TMatrSet;
    _Get:TMatrGet;
    _Rows:TMatrSize;
    _Cols:TMatrSize;
  end;
  PMatrix = ^TMatrix;

  TArrSet = procedure(var Item:TData; var Val:TData) of object;
  TArrGet = function(Var Item:TData; var Val:TData):boolean of object;
  TArrCount = function:integer of object;
  TArrAdd = procedure(var Val:TData) of object;
  TXArray = record
    _Set:TArrSet;
    _Get:TArrGet;
    _Count:TArrCount;
    _Add:TArrAdd;
  end;
  PArray = ^TXArray;
  // ~~~~~~~~~~~~~~~ ARRAYS ~~~~~~~~~~~~~~~
  // ##array
  TArray = class
    private
     Arr:TXArray;
    protected
     function DataToPointer(var Data:TData):cardinal; virtual;
     procedure PointerToData(Data:cardinal; var Result:TData); virtual;
     procedure Delete(Value:cardinal); virtual;
    protected
     procedure Save(P:pointer; Data:cardinal); virtual; abstract;
     procedure Load(P:pointer; var Data:cardinal); virtual; abstract;
     function Swap(d1,d2:cardinal):boolean; virtual;
    public
     _prop_FileName:string;
     _prop_FileFormat:byte;
     _prop_UseName:boolean;

     _data_FileName:THI_Event;

     Items:PStrListEx;

     constructor Create;
     destructor Destroy; override;
     procedure SetItems(Value:PStrListEx);
     procedure _work_doSave(var _Data:TData; Index:word);
     procedure _work_doLoad(var _Data:TData; Index:word);
     procedure _work_doClear(var _Data:TData; Index:word);
     procedure _work_doSort(var _Data:TData; Index:word);
     procedure _var_Array(var _Data:TData; Index:word);
     procedure _var_Count(var _Data:TData; Index:word);

     function Count:integer;
     procedure Write(var Item:TData; var Val:TData);
     function Read(Var Item:TData; var Val:TData):boolean;
     procedure Add(var Val:TData);
  end;

  function MakeArrayInteger(Names:PChar; Values:array of integer):PStrListEx;
  function MakeArrayBitmap(Names:PChar; Values:array of integer):PStrListEx;
  function MakeArrayReal(Names:PChar; Values:array of real):PStrListEx;
  function MakeArrayWave(Names:PChar; Values:array of PChar):PStrListEx;

var Null:THI_Event=(Event:nil;index:0); //!!!  
    _data_Empty:TData=(data_type:0;idata:0;sdata:'';rdata:0;next:nil;ldata:nil);
    GHandle:cardinal=0;
    NeedInit:boolean=false; //!!!     InitDo
    ScreenDPI:integer=0;

function _DoEvent(Event:TEvent; Index:word{$ifdef _DEBUG_}; ID,Idx:Cardinal{$endif}):THI_Event;
function _hi_SizeFnt(Sz:integer):integer; //     

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function ToStringEvent(const PointData:THI_Event):string;
function ToIntegerEvent(const PointData:THI_Event):integer;
function ToRealEvent(const PointData:THI_Event):real;
function ToStreamEvent(const PointData:THI_Event):PStream;
function ToBitmapEvent(const PointData:THI_Event):PBitmap;
function ToIconEvent(const PointData:THI_Event):PIcon;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ##ReadXXX
function ReadString(var Data:TData; PointData:THI_Event; const Def:string=''):string;
function ReadInteger(var Data:TData; PointData:THI_Event; Def:THiInt=0):THiInt;
function ReadReal(var Data:TData; PointData:THI_Event; Def:real=0):real;
function ReadBool(var Data:TData):boolean;
function ReadMTData(var Data:TData; PointData:THI_Event; Def:PData=nil):TData;
function ReadData(var Data:TData; PointData:THI_Event; Def:PData=nil):TData;
function ReadStream(var Data:TData; PointData:THI_Event; Def:PStream=nil):PStream;
function ReadBitmap(var Data:TData; PointData:THI_Event; Def:PBitmap=nil):PBitmap;
function ReadIcon(var Data:TData; PointData:THI_Event; Def:PIcon=nil):PIcon;
function ReadMatrix(PointData:THI_Event):PMatrix;
function ReadArray(PointData:THI_Event):PArray;

function ReadControl(PointData:THI_Event; const CName:string):PControl;
//   
procedure _ReadData(var Data:TData; PointData:THI_Event);
//     MT 
function ReadFromThread(var Data:TData):TData;

// ##ToXXX
function ToString(const Data:TData):string;
function ToInteger(const Data:TData):THiInt;
function ToReal(const Data:TData):real;
function ToStream(var Data:TData):PStream;
function ToBitmap(var Data:TData):PBitmap;
function ToIcon(var Data:TData):PIcon;
function ToObject(var Data:TData):pointer;
function ToFont(var Data:TData):PFontRec;

// ##_hi_onEvent
procedure _hi_OnEvent_(const PointEvent:THI_Event;var Data:TData);// Data
procedure _hi_OnEvent(const PointEvent:THI_Event;var Data:TData); overload;
procedure _hi_OnEvent(const PointEvent:THI_Event;Value:THiInt); overload;
procedure _hi_OnEvent(const PointEvent:THI_Event;Value:real); overload;
procedure _hi_OnEvent(const PointEvent:THI_Event;const Value:string); overload;
procedure _hi_OnEvent(const PointEvent:THI_Event;Value:PStream); overload;
procedure _hi_OnEvent(const PointEvent:THI_Event); overload;
procedure _hi_OnEvent(const PointEvent:THI_Event;Value:PBitmap); overload;
procedure _hi_OnEvent(const PointEvent:THI_Event;const Value:TFontRec); overload;

// ##_hi_CreateEvent
procedure _hi_CreateEvent_(var _Data:TData; Event:PHI_Event); overload; //   
procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event); overload;
procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; const Data:TData); overload;
procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; Data:integer); overload;
procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; Data:real); overload;
procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; const Data:string); overload;
procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; const Data:PStream); overload;
procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; const Data:PBitmap); overload;

// ##_DoData
function _DoData(Value:THiInt):TData; overload;
function _DoData(Value:real):TData; overload;
function _DoData(const Value:string):TData; overload;
function _DoData(const Value:TData):TData; overload;
function _DoData(Value:PStream):TData; overload;
function _DoData(Value:PBitmap):TData; overload;
function _DoData(Value:PMatrix):TData; overload;

// ##CreateData
procedure dtData(var Data:TData; const Value:TData);
procedure dtNull(var Data:TData);
procedure dtInteger(var Data:TData; Value:integer);
procedure dtReal(var Data:TData; Value:real);
procedure dtString(var Data:TData; const Value:string);
procedure dtArray(var Data:TData; Value:PArray);
procedure dtMatrix(var Data:TData; Value:PMatrix);
procedure dtBitmap(var Data:TData; Value:PBitmap);
procedure dtStream(var Data:TData; Value:PStream);
procedure dtObject(var Data:TData; id:integer; Value:pointer);
procedure dtRect(var Data:TData; Value:pointer);
procedure dtIcon(var Data:TData; Value:PIcon);

function _IsStr(const Data:TData):boolean;
function _IsInteger(const Data:TData):boolean;
function _IsFont(const Data:TData):boolean;
function _IsStream(const Data:TData):boolean;
function _IsBitmap(const Data:TData):boolean;
function _IsIcon(const Data:TData):boolean;
function _IsObject(const Data:TData; id:integer):boolean;
function _IsNull(const Data:TData):boolean;
function _IsBreak(const Data:TData):boolean;
function _IsType(const Data:TData):integer;

procedure GenGUID(var g:integer);

function PosEx(const SubStr, S: string; Offset: Cardinal = 1): Integer;
type Tbackrep=function(Pos:integer):boolean of object;
procedure Replace(var Str:string;const substr,dest:string; back:TbackRep=nil);
function StrIComp(const Str1, Str2: PChar): Integer;

function _hi_OnMessage(Message:TOnMessage;var Msg: TMsg; var Rslt: Integer):boolean;

procedure UPD_Init;
procedure UPD_Clear;
function TCPGetHostByName(name: pchar): string;

function ReadHandle:HWND;
function ReadFileName(const FName:string):string;
function WinDirs(const FName:string):string;

function LoadResData(const Name:PChar):pointer;
function LoadResStream(const Name:PChar):PStream;
function hiCreateFont(const Name:string; Size,Style:byte; Color:TColor; CharSet:byte):TFontRec;
procedure SetFont(Font:PGraphicTool; Value:byte);

function GetString(var _Data:TData):string; //!!!      TData
procedure _Debug; overload;
procedure _Debug(const info:string); overload;
procedure _Debug(info:integer); overload;
procedure _Debug(var _Data:TData; ident:string='Data-Debug'); overload; //!!!   MT
function GetTok(var s:string; const c:char):string;

procedure BmpTransparent(bmp:PBitmap);
function ToSysColor(Color:cardinal):TColor;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ MT technology ~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure AddMTData(p,q:PData; var forFree:PData);
procedure FreeData(Data:PData);
procedure CopyData(Dest,Src:PData);

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ARRAYS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function ToIntIndex(var Data:TData):integer;
function CreateArray(_Set:TArrSet; _Get:TArrGet; _Count:TArrCount; _Add:TArrAdd):PArray;

function CreateMatrix(_Set:TMatrSet; _Get:TMatrGet; _X,_Y:TMatrSize):PMatrix;

{$ifdef F_P}
function NewThreadForFPC:PTHread;
{$endif}

procedure EventOn;
procedure EventOff;

procedure InitAdd(proc:TInitProc);
procedure InitDo;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SPLITTER ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
type
  TNewSpl=function(P:PControl;MPrev,MNext:Integer;C:TColor;S:Integer):PControl;
function LObjSp(P:PControl;MPrev,MNext:Integer;C:TColor;S:Integer):PControl;
function RObjSp(P:PControl;MPrev,MNext:Integer;C:TColor;S:Integer):PControl;
function FObjSp(P:PControl;MPrev,MNext:Integer;C:TColor;S:Integer):PControl;
const
  spLowered:TNewSpl=LObjSp;
  spRaised: TNewSpl=RObjSp;
  spFlat:   TNewSpl=FObjSp;
  spNone:   TNewSpl=nil;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ GRAFICS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
type
  AGRBQuad = array [0..0] of RGBQuad;
  PAGRBQuad = ^AGRBQuad;
  PPoints = ^TPoints;
  TPoints = array[0..0] of TPoint;
function GetRGB(const Color: TColor): TRGB;
function GetLightColor(Color: TColor; Light: Byte) : TColor;
function GetShadeColor(Color: TColor; Shade: Byte) : TColor;
procedure _Polyline(DC: HDC;const Points: array of TPoint);
procedure _Gradient(Sender:PControl; DC:HDC; cbRect:TRect; Gradient:boolean; DepthGradient:integer; LightColor,DarkColor,ColorFrame:TColor; Frame,Horizontal,InversGrad:boolean);



implementation

uses Debug;

var WSA_Init:boolean=false;
    _guids_:integer=0;
    InitMan:array of TInitProc = nil; //!!!    

//   
type
  TArr_nil = object
    procedure _Set(var Item:TData; var Val:TData);
    procedure _Add(var Val:TData);
  end;
var _arr:TArr_nil;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FONT ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function _hi_SizeFnt;
var dc:THandle;
begin
  if ScreenDPI=0 then begin
    dc := GetDC(0);
    ScreenDPI := GetDeviceCaps(dc,LOGPIXELSY);
    ReleaseDC(0,dc);
  end;
  Result := (Sz*ScreenDPI+36)div -72;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SPLITTER ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function LObjSp;
begin
  Result := NewSplitterEx(P,MPrev,MNext,esLowered).SetSize(S,S);
  Result.Color := C;
end;
function RObjSp;
begin
  Result := NewSplitterEx(P,MPrev,MNext,esRaised).SetSize(S,S);
  Result.Color := C;
end;
function FObjSp;
begin
  Result := NewSplitterEx(P,MPrev,MNext,esNone).SetSize(S,S);
  Result.Color := C;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ InitMan ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//!!!    
procedure InitAdd;
begin
  SetLength(InitMan,length(InitMan)+1);
  InitMan[high(InitMan)] := Proc;
end;

procedure InitDo;
var i:integer;
begin
  i := 0;
  while i<length(InitMan) do
   begin
    InitMan[i];
    inc(i);
   end;
  SetLength(InitMan,0);
  NeedInit := True;
end;
//!!!  ...
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function GetTok(var s:string; const c:char):string;
var p:integer;
begin
   p := Pos(c,s);
   if p > 0 then
     begin
       Result := Copy(s,1,p-1);
       if p = Length(s) then
         s := ''
       else Delete(s,1,p);
     end
   else Result := s;
end;

procedure BmpTransparent;
var
  i,j:word;
  c:TColor;
begin
  if Bmp.Empty then exit;

  c := Bmp.Pixels[0,0];
   for i := 0 to Bmp.Width-1 do
    for j := 0 to Bmp.Height-1 do
      if Bmp.Pixels[i,j] = c then
       Bmp.Pixels[i,j] := clBtnFace; //GetSysColor(COLOR_BTNFACE);
end;

function ToSysColor(Color:cardinal):TColor;
begin
   if Color > $00FFFFFF then
     Result := GetSysColor(Color and $000000FF)
   else Result := Color;
end;

procedure _Debug;
var P:pChar;
begin
   FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER+FORMAT_MESSAGE_FROM_SYSTEM,nil,GetLastError,LANG_NEUTRAL,@P,0,nil);
   MessageBox(ReadHandle,P,'GetLastError',MB_OK);
   LocalFree(dword(P));
end;

procedure _Debug(const info:string);
begin
   MessageBox(ReadHandle,PChar(info),'String-Debug',MB_OK);
end;

procedure _Debug(info:integer);
begin
   MessageBox(ReadHandle,PChar(int2str(info)),'Integer-Debug',MB_OK);
end;

procedure _Debug(var _Data:TData; ident:string='Data-Debug'); //!!!  
  function GetStr(var _Data:TData):string;
  begin
    Result := GetString(_Data);
    if _Data.data_type<=high(DataNames) then
     begin
      if Result<>'' then Result := ':'#9+Result;
      Result := DataNames[_Data.data_type] + Result;
     end
    else Result := 'Unknown: '+int2str(_Data.data_type);
  end;
begin
  {$ifdef MT_ENABLED}
  if (_Data.data_type=data_null)or(_Data.ldata=nil) then
    MessageBox(ReadHandle,PChar(GetStr(_Data)),PChar(ident),MB_OK)
  else if MessageBox(ReadHandle,PChar(GetStr(_Data)),PChar(ident),MB_YESNO)=IDYES then
    _Debug(_Data.ldata^,ident);
  {$else}
    MessageBox(ReadHandle,PChar(GetStr(_Data)),PChar(ident),MB_OK)
  {$endif}
end;

function GetString(var _Data:TData):string;
begin
  Result := '';
  case _isType(_Data) of
    data_break : Result := 'BREAK';
    data_null  : Result := 'NULL';
    data_int   : Result := int2str(_Data.idata);
    data_str   : Result := '"' + _Data.sdata + '"';
    data_object: Result := 'ID: ' + Double2str(_Data.rdata);
    data_real  : begin
      Result := double2str(_Data.rdata);
      if Pos('.',Result) = 0 then Result := Result + '.0';
    end;
    data_array:
      Result := 'arrCount: ' + int2str(PArray(_data.idata)._Count);
    data_matr:
      Result := 'mtxSize: ' + int2str(PMatrix(_data.idata)._Cols)
                  +'x' + int2str(PMatrix(_data.idata)._Rows);
    data_stream:
      if pointer(_data.idata) = nil then Result := 'noStream'
      else Result := 'stSize=' + int2str(PStream(_data.idata).Size)
         +', stPosition=' + int2str(PStream(_data.idata).Position);
    data_bitmap:
      if pointer(_data.idata) = nil then Result := 'noBitmap'
      else Result := 'bmpSize: ' + int2str(PBitmap(_data.idata).Width)
                             +'x' + int2str(PBitmap(_data.idata).Height);
  end;
end;

function _DoEvent;
begin
   Result.Event := Event;
   Result.Index := Index;
   {$ifdef _DEBUG_}
   Result.dbgID := ID;
   Result.dbgIndex := Idx;
   {$endif}
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

procedure __hi_OnEvent_(const PointEvent:THI_Event;var Data:TData);
begin
end;

var OnEvent:procedure(const PointEvent:THI_Event;var Data:TData) = __hi_OnEvent_;
    OnData: procedure(const PointEvent:THI_Event;var Data:TData) = __hi_OnEvent_;

function ToStringEvent;
var dt:TData;
begin
  dt.Data_type := data_null;
  OnData(PointData,dt);
  Result := ToString(dt);
end;

function ToIntegerEvent;
var dt:TData;
begin
  dt.Data_type := data_null;
  OnData(PointData,dt);
  Result := ToInteger(dt);
end;

function ToRealEvent;
var dt:TData;
begin
  dt.Data_type := data_null;
  OnData(PointData,dt);
  Result := ToReal(dt);
end;

function ToStreamEvent;
var dt:TData;
begin
  dt.Data_type := data_null;
  OnData(PointData,dt);
  Result := ToStream(dt);
end;

function ToBitmapEvent;
var dt:TData;
begin
  dt.Data_type := data_null;
  OnData(PointData,dt);
  Result := ToBitmap(dt);
end;

function ToIconEvent;
var dt:TData;
begin
  dt.Data_type := data_null;
  OnData(PointData,dt);
  Result := ToIcon(dt);
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function ReadString(var Data:TData; PointData:THI_Event; const Def:string):string;
var dt:TData;
begin
   if Assigned(PointData.Event) then
     begin
       dt.Data_type := data_null;
       OnData(PointData,dt);
       if dt.data_type <> data_break then //!!! data_break-feature
        begin
         Result := ToString(dt);
         exit;
        end;
     end;
   if(Def = '')and(Data.data_type <> data_null) then
    begin
      Result := ToString(Data);
      {$ifdef MT_ENABLED}if Data.ldata <> nil then
        Data := Data.ldata^
      else{$endif}
      Data.Data_type := data_null;
    end
   else Result := Def;
end;

function ToString;
begin
   case Data.data_type of
    data_str : Result := Data.sdata;
    data_int : Result := Int2Str( Data.idata );
    data_real: Result := Double2Str(Data.rdata);
    else Result := '';
   end;
end;

function ReadInteger;
var dt:TData;
begin
   if Assigned(PointData.Event) then
     begin
       dt.Data_type := data_null;
       OnData(PointData,dt);
       if dt.data_type <> data_break then //!!! data_break-feature
        begin
         Result := ToInteger(dt);
         exit;
        end;
     end;
   if(Def = 0)and( Data.data_type <> data_null )then
    begin
      Result := ToInteger(Data);
      {$ifdef MT_ENABLED}if Data.ldata <> nil then
        Data := Data.ldata^
      else{$endif}
      Data.Data_type := data_null;
    end
   else Result := Def;
end;

function ToInteger;
begin
   case Data.data_type of
     data_str : Result := Str2Int(Data.sdata);
     data_int : Result := Data.idata;
     data_real: Result := Round(Data.rdata);
     else Result := 0;
   end;
end;

function ReadReal(var Data:TData; PointData:THI_Event; Def:real):real;
var dt:TData;
begin
   if Assigned(PointData.Event) then
     begin
       dt.Data_type := data_null;
       OnData(PointData,dt);
       if dt.data_type <> data_break then //!!! data_break-feature
        begin
         Result := ToReal(dt);
         exit;
        end;
     end;
   if (Def = 0)and( Data.data_type <> data_null ) then
    begin
     Result := ToReal(Data);
      {$ifdef MT_ENABLED}if Data.ldata <> nil then
        Data := Data.ldata^
      else{$endif}
     Data.Data_type := data_null;
    end
   else Result := Def;
end;

function ToReal;
begin
   case Data.data_type of
    data_real: Result := Data.rdata;
    data_int : Result := Data.idata;
    data_str : Result := Str2Double(Data.sdata);
    else Result := 0;
   end;
end;

function ToStream;
begin
   case Data.data_type of
    data_stream: Result := PStream(Data.idata);
    else Result := nil;
   end;
end;

function ToBitmap;
begin
   case Data.data_type of
    data_bitmap: Result := PBitmap(Data.idata);
    else Result := nil;
   end;
end;

function ToIcon;
begin
   case Data.data_type of
    data_icon: Result := PIcon(Data.idata);
    else Result := nil;
   end;
end;

function ToObject;
begin
   case Data.data_type of
    data_object: Result := pointer(Data.idata);
    else Result := nil;
   end;
end;

function ToFont;
begin
   case Data.data_type of
    data_font: Result := pfontrec(Data.idata);
    else Result := nil;
   end;
end;

function ReadControl;
var dt:TData;
begin
  dt.Data_type := data_null;
  _ReadData(dt,PointData);
  if( Dt.Data_type = data_int)and(Dt.sdata = CName)then
   Result := PControl(dt.idata)
  else Result := nil;
end;

function ReadBool(var Data:TData):boolean;
begin
  Result := (Data.Data_type<>data_int)or(Data.idata<>0);
end;

function ReadMTData(var Data:TData; PointData:THI_Event; Def:PData):TData;
begin {$ifdef MT_ENABLED}
  if Assigned(PointData.Event) then begin
    dtNull(Result);
    OnData(PointData,Result);
    if Result.data_type <> data_break then exit;  //!!! data_break-feature
  end;
  if(Def = nil)or(Def.data_type = data_null) then begin
    Result := Data;
    dtNull(Data);
  end else Result := Def^;
{$endif}end;

function ReadData(var Data:TData; PointData:THI_Event; Def:PData):TData;
begin
  if Assigned(PointData.Event) then begin
    dtNull(Result);
    OnData(PointData,Result);
    Result.ldata := nil; //!!!!!!!!!!!!!
    if Result.data_type <> data_break then exit;  //!!! data_break-feature
  end;
  if(Def = nil)or(Def.data_type = data_null) then begin
    Result := Data;
    {$ifdef MT_ENABLED}Result.ldata := nil;
    if Data.data_type = data_null then Data.ldata := nil;
    if Data.ldata <> nil then Data := Data.ldata^
    else {$endif}Data.data_type := data_null;
  end else Result := Def^;
end;

procedure _ReadData;
begin
   if Assigned(PointData.Event) then
     OnData(PointData,Data)
   else Data.data_type := data_break;  //!!! data_break-feature
end;

function ReadFromThread(var Data:TData):TData;
var e:THI_Event;
begin
   e.Event := nil;
   Result := ReadData(Data,e,nil);
end;

function ReadStream;
var dt:TData;
begin
   if Assigned(PointData.Event) then
     begin
       dtNull(dt);
       OnData(PointData,dt);
       if dt.data_type <> data_break then  //!!! data_break-feature
        begin
         if dt.data_type = data_stream then
           Result := PStream(dt.idata)
         else Result := nil;
         exit;
        end;
     end;
   if (Def = nil)and(Data.data_type = data_stream) then
     begin
      Result := PStream(Data.idata);
      {$ifdef MT_ENABLED}if Data.ldata <> nil then
        Data := Data.ldata^
      else{$endif}
        data.Data_type := data_null;
     end
   else Result := Def;
end;

function ReadBitmap;
var dt:TData;
begin
   if Assigned(PointData.Event) then
     begin
      dt.Data_type := data_null;
      OnData(PointData,dt);
      if dt.data_type <> data_break then  //!!! data_break-feature
       begin
        if dt.data_type = data_bitmap then
          Result := PBitmap(dt.idata)
        else Result := nil;
        exit;
       end;
     end;
   if (Def = nil)and(Data.Data_type = data_bitmap) then
     begin
       Result := PBitmap(data.idata);
      {$ifdef MT_ENABLED}if Data.ldata <> nil then
        Data := Data.ldata^
      else{$endif}
       data.Data_type := data_null;
     end
   else Result := Def;
end;

function ReadIcon;
var dt:TData;
begin
   if Assigned(PointData.Event) then
     begin
       dt.Data_type := data_null;
       OnData(PointData,dt);
       if dt.data_type = data_icon then
         Result := PIcon(dt.idata)
       else Result := nil;
     end
   else if (Def = nil)and(Data.Data_type = data_icon) then
     begin
       Result := PIcon(data.idata);
      {$ifdef MT_ENABLED}
      if Data.ldata <> nil then
        Data := Data.ldata^
      else
      {$endif}
       data.Data_type := data_null;
     end
   else Result := Def;
end;

function ReadMatrix;
var dt:TData;
begin
   Result := nil;
   if Assigned(PointData.Event) then
    begin
      dt.data_type := data_null; //!!!
      OnData(PointData,dt);
      if dt.Data_type = data_matr then
        Result := PMatrix(Dt.idata);
    end;
end;

function ReadArray;
var dt:TData;
begin
   Result := nil;
   if Assigned(PointData.Event) then
    begin
      dt.data_type := data_null; //!!!
      OnData(PointData,dt);
      if dt.Data_type = data_array then
        Result := PArray(Dt.idata);
    end;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

procedure __hi_OnEvent(const PointEvent:THI_Event;var Data:TData);
var P:PHI_Event;
begin
  P := @PointEvent;
  while Assigned(P.Event) do begin
    {$ifdef _DEBUG_}CallEvent(2,P^,Data);{$endif}
    P.Event(Data,P.Index);
    if(Data.data_type and $80)=0 then break;
    dec(Data.data_type,$80);
    P := PHI_Event(Data.next);
  end;
end;

procedure __hi_OnData(const P:THI_Event;var Data:TData);
begin
  if Assigned(P.Event) then begin
    {$ifdef _DEBUG_}CallEvent(4,P,Data);{$endif}
    P.Event(Data,P.Index);
    {$ifdef _DEBUG_}CallEvent(4,P,Data);{$endif}
  end;
end;

procedure EventOn;
begin
  OnEvent := __hi_OnEvent;
  OnData  := __hi_OnData;
end;

procedure EventOff;
begin
  OnEvent := __hi_OnEvent_;
  OnData  := __hi_OnEvent_;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

procedure _hi_CreateEvent_(var _Data:TData; Event:PHI_Event); //   
begin
  inc(_Data.data_type,$80);
  _Data.Next := Event;
end;

procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event);
begin
  _Data.data_type := data_null + $80;
  _Data.Next := Event;
end;

procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; const Data:TData);
begin
  _Data := Data;
  inc(_Data.data_type,$80);
  _Data.Next := Event;
end;

procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; Data:integer);
begin
  _Data.Data_type := Data_int + $80;
  _Data.idata := Data;
   {$ifdef MT_ENABLED}_Data.ldata := nil;{$endif}
  _Data.Next := Event;
end;

procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; Data:real);
begin
  _Data.Data_type := Data_real + $80;
  _Data.rdata := Data;
   {$ifdef MT_ENABLED}_Data.ldata := nil;{$endif}
  _Data.Next := Event;
end;

procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; const Data:string);
begin
  _Data.Data_type := Data_str + $80;
  _Data.sdata := Data;
   {$ifdef MT_ENABLED}_Data.ldata := nil;{$endif}
  _Data.Next := Event;
end;

procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; const Data:PStream);
begin
  _Data.Data_type := Data_stream + $80;
  _Data.idata := integer(Data);
   {$ifdef MT_ENABLED}_Data.ldata := nil;{$endif}
  _Data.Next := Event;
end;

procedure _hi_CreateEvent(var _Data:TData; Event:PHI_Event; const Data:PBitmap);
begin
  _Data.Data_type := Data_bitmap + $80;
  _Data.idata := integer(Data);
   {$ifdef MT_ENABLED}_Data.ldata := nil;{$endif}
  _Data.Next := Event;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

procedure _hi_OnEvent(const PointEvent:THI_Event;var Data:TData);
begin
   OnEvent(PointEvent,Data);
end;

procedure _hi_OnEvent_(const PointEvent:THI_Event;var Data:TData);
var dt:TData;//
begin
   dt := Data;
   OnEvent(PointEvent,dt);
end;

procedure _hi_OnEvent(const PointEvent:THI_Event;Value:THiInt);
var Data:TData;
begin
   dtInteger(Data,Value);
   OnEvent(PointEvent,Data);
end;

procedure _hi_OnEvent(const PointEvent:THI_Event;Value:real);
var Data:TData;
begin
   dtReal(Data,Value);
   OnEvent(PointEvent,Data);
end;

procedure _hi_OnEvent(const PointEvent:THI_Event;const Value:string);
var Data:TData;
begin
   dtString(Data,Value);
   OnEvent(PointEvent,Data);
end;

procedure _hi_OnEvent(const PointEvent:THI_Event;Value:PStream);
var Data:TData;
begin
   dtStream(Data,Value);
   OnEvent(PointEvent,Data);
end;

procedure _hi_OnEvent(const PointEvent:THI_Event;Value:PBitmap);
var Data:TData;
begin
   dtBitmap(Data,Value);
   OnEvent(PointEvent,Data);
end;

procedure _hi_OnEvent(const PointEvent:THI_Event);
var Data:TData;
begin
   dtNull(Data);
   OnEvent(PointEvent,Data);
end;

procedure _hi_OnEvent(const PointEvent:THI_Event;const Value:TFontRec);
var Data:TData;
begin
   Data.Data_type := data_font;
   Data.idata := integer(@Value);
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
   OnEvent(PointEvent,Data);
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//##__DoData
function _DoData(Value:THiInt):TData;
begin
   dtInteger(Result,Value);
end;

function _DoData(Value:real):TData;
begin
   dtReal(Result,Value);
end;

function _DoData(const Value:string):TData;
begin
   dtString(Result,Value);
end;

function _DoData(const Value:TData):TData;  //   ????
begin
   dtData(Result,Value);
end;

function _DoData(Value:PStream):TData;
begin
   dtStream(Result,Value);
end;

function _DoData(Value:PBitmap):TData;
begin
   dtBitmap(Result,Value);
end;

function _DoData(Value:PMatrix):TData;
begin
   dtMatrix(Result,Value);
end;

procedure dtData(var Data:TData; const Value:TData);
begin
   Data := Value;
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtNull(var Data:TData);
begin
   Data.data_type := data_null;
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtInteger(var Data:TData; Value:integer);
begin
   Data.data_type := data_int;
   Data.idata := Value;
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtReal(var Data:TData; Value:real);
begin
   Data.data_type := data_real;
   Data.rdata := Value;
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtString(var Data:TData; const Value:string);
begin
   Data.data_type := data_str;
   Data.sdata := Value;
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtArray(var Data:TData; Value:PArray);
begin
   Data.data_type := data_array;
   Data.idata := integer(Value);
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtMatrix(var Data:TData; Value:PMatrix);
begin
   Data.data_type := data_matr;
   Data.idata := integer(Value);
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtBitmap(var Data:TData; Value:PBitmap);
begin
   Data.data_type := data_bitmap;
   Data.idata := integer(Value);
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtStream(var Data:TData; Value:PStream);
begin
   Data.data_type := data_stream;
   Data.idata := integer(Value);
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtRect(var Data:TData; Value:pointer);
begin
   Data.data_type := data_rect;
   Data.idata := integer(Value);
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtIcon(var Data:TData; Value:PIcon);
begin
   Data.data_type := data_icon;
   Data.idata := integer(Value);
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

procedure dtObject(var Data:TData; id:integer; Value:pointer);
begin
   Data.data_type := data_object;
   Data.idata := integer(Value);
   Data.rdata := id;  // xxxx
   Data.Next := nil;
   {$ifdef MT_ENABLED}Data.ldata := nil;{$endif}
end;

function _IsStr(const Data:TData):boolean;
begin
   Result := Data.Data_type = data_str;
end;

function _IsInteger(const Data:TData):boolean;
begin
   Result := Data.Data_type = data_int;
end;

function _IsFont(const Data:TData):boolean;
begin
   Result := Data.Data_type = data_font;
end;

function _IsStream(const Data:TData):boolean;
begin
   Result := Data.Data_type = data_stream;
end;

function _IsBitmap(const Data:TData):boolean;
begin
   Result := Data.Data_type = data_bitmap;
end;

function _IsIcon(const Data:TData):boolean;
begin
   Result := Data.Data_type = data_icon;
end;

function _IsObject(const Data:TData; id:integer):boolean;
begin
   Result := (Data.Data_type = data_object) and ( data.rdata > 0) and ( data.rdata = id);
end;

function _IsNull(const Data:TData):boolean;
begin
   Result := Data.Data_type = data_null;
end;

function _IsBreak(const Data:TData):boolean;
begin
   Result := Data.Data_type = data_break;
end;

function _IsType(const Data:TData):integer;
begin
   Result := Data.data_type;
end;

procedure GenGUID;
begin
   if g = 0 then
    begin
     inc(_guids_);
     g := _guids_;
    end;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function StrIComp(const Str1, Str2: PChar): Integer; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        MOV     EDI,EDX
        MOV     ESI,EAX
        MOV     ECX,0FFFFFFFFH
        XOR     EAX,EAX
        REPNE   SCASB
        NOT     ECX
        MOV     EDI,EDX
        XOR     EDX,EDX
@@1:    REPE    CMPSB
        JE      @@4
        MOV     AL,[ESI-1]
        CMP     AL,'a'
        JB      @@2
        CMP     AL,'z'
        JA      @@2
        SUB     AL,20H
@@2:    MOV     DL,[EDI-1]
        CMP     DL,'a'
        JB      @@3
        CMP     DL,'z'
        JA      @@3
        SUB     DL,20H
@@3:    SUB     EAX,EDX
        JE      @@1
@@4:    POP     ESI
        POP     EDI
end;

function PosEx(const SubStr, S: string; Offset: Cardinal = 1): Integer;
var
  I,X: Integer;
  Len, LenSubStr: Integer;
begin
  if Offset = 1 then
    Result := Pos(SubStr, S)
  else if Length(SubStr) = 0 then
    Result := 0
  else
   begin
    I := Offset;
    LenSubStr := Length(SubStr);
    Len := Length(S) - LenSubStr + 1;
    while I <= Len do
    begin
      if S[I] = SubStr[1] then
      begin
        X := 1;
        while (X < LenSubStr) and (S[I + X] = SubStr[X + 1]) do
          Inc(X);
        if (X = LenSubStr) then
        begin
          Result := I;
          exit;
        end;
      end;
      Inc(I);
    end;
    Result := 0;
   end;
end;

procedure Replace;
var p,q:integer;
begin
   q := Length(dest);
   p := Pos(substr,str);
   while p > 0 do begin
     if (@back=nil)or back(p) then begin
       Delete(str,p,length(substr));
       Insert(dest,Str,p);
       inc(p,q);
     end else inc(p);
     p := PosEx(substr,str,p);
   end;
end;

function _hi_OnMessage(Message:TOnMessage;var Msg: TMsg; var Rslt: Integer):boolean;
begin
   if Assigned(Message) then
    Result := Message(Msg,Rslt)
   else Result := false;
end;

procedure UPD_Init;
var wsaData:TWSAData;
begin
  if not WSA_Init then
   begin
     WSAStartup($101,wsaData);
     WSA_Init := true;
   end;
end;

procedure UPD_Clear;
begin
   if WSA_Init then
   begin
     WSACleanup;
     WSA_Init := false;
   end;
end;

function TCPGetHostByName(name: pchar): string;
var
  host:phostent;
  adr:in_addr;
begin
  host := gethostbyname(name);
  if host = nil then
   Result := ''
  else
   begin
    move(host.h_addr^^,adr,host.h_length);
    Result := inet_ntoa(adr);
   end;
end;

function ReadHandle:HWND;
begin
   if Assigned(Applet) then
     begin
      if not Assigned(Applet.ActiveControl) then
        Result := Applet.Children[0].Handle
      else Result := Applet.ActiveControl.handle
     end
   else Result := GHandle;
end;

function ReadFilename;
begin
   Result := WinDirs(FName);
   if ExtractFilePath(Result) = '' then
    Result := GetStartDir + Result;
end;

function WinDirs;
begin
   Result := FName;
   Replace(Result,'%windir%',GetWindowsDir);
   Replace(Result,'%tmpdir%',GetTempDir);
   Replace(Result,'%sysdir%',GetSystemDir);
end;

//var s:string;

function LoadResData;
var
  hResource: cardinal;
begin
   //s := 'hello world';
   //Result := @s[1];
   hResource := LoadResource( hInstance, FindResource(hInstance,PChar(name), PChar(100)));
   Result := LockResource(hResource);
   FreeResource(hResource);
end;

function LoadResStream;
var
  hResource: cardinal;
  hRes:cardinal;
  p:pointer;
begin
   Result := NewMemoryStream;

   hRes := FindResource(hInstance,PChar(name), PChar(100));
   hResource := LoadResource( hInstance, hRes);
   hRes := SizeofResource(hinstance,hRes);
   p := LockResource(hResource);
   Result.Write(p^,hReS);
   Result.Position := 0;
   FreeResource(hResource);
end;

function hiCreateFont;
begin
   Result.Name := Name;
   Result.Size := Size;
   Result.Style := Style;
   Result.Color := Color;
   Result.CharSet := CharSet;
end;

procedure SetFont;
{$ifdef F_P}
var fs:TFontStyle;
{$endif}
begin
   {$ifdef F_P}
   if Value and 1 > 0 then
    fs := [fsBold]
   else fs := [];
   if Value and 2 > 0 then
     Include(fs,fsItalic);
   if Value and 4 > 0 then
     Include(fs, fsUnderline);
   if Value and 8 > 0 then
     Include(fs,fsItalic);
   Font.FontStyle := fs;
   {$else}
   Font.FontStyle := TFontStyle(pointer(@Value)^);
   {$endif}
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ARRAYS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

constructor TArray.Create;
begin
   inherited Create;
   Items := NewStrListEx;
   Arr._Count := Count;
   Arr._Set := Write;
   Arr._Get := Read;
   Arr._Add := Add;
end;

destructor TArray.Destroy;
var i:integer;
begin
  for i := 0 to Items.Count-1 do
   Delete(Items.Objects[i]);
  Items.Free;
  inherited Destroy;
end;

procedure TArray._work_doSave;
var
  fn:string;
  st:PStream;
  Lst:PStrList;
  i:cardinal;
  s:string;
begin
   fn := ReadString(_data,_data_FileName,_prop_FileName);
   if Items.Count > 0 then
   if _prop_FileFormat = 0 then
    begin
      st := NewWriteFileStream(fn);
      for i := 0 to Items.Count-1 do
       Save(st,Items.Objects[i]);
      st.Free;
    end
   else
    begin
      Lst := NewStrList;
      for i := 0 to Items.Count-1 do
       begin
        Save(@s,Items.Objects[i]);
        Lst.Add(Items.Items[i] + '=' + s);
       end;
      Lst.SaveToFile(fn);
      Lst.Free;
    end;
end;

procedure TArray._work_doLoad;
var fn:string;
    st:PStream;
    Lst:PStrList;
    i:integer;
    c:cardinal;
begin
   fn := ReadString(_data,_data_FileName,_prop_FileName);
   if FileExists(fn) then
    begin
      _work_doClear(_data,0);
      if _prop_FileFormat = 0 then
       begin
        st := NewReadFileStream(fn);
        while st.Position < st.Size do
         begin
           Items.Add('');
           Load(st,c);
           Items.Objects[Items.Count-1] := c;
         end;
        st.Free;
       end
      else
       begin
        Lst := NewStrList;
        Lst.LoadFromFile(fn);
        for i := 0 to Lst.Count-1 do
         begin
          fn := Lst.Items[i];
          Items.Add(GetTok(fn,'='));
          Load(@fn,c);
          Items.Objects[i] := c;
         end;
        Lst.Free;
       end;
    end;
end;

procedure TArray._work_doClear;
var i:integer;
begin
   for i := 0 to Items.Count-1 do
    Delete(Items.Objects[i]);
   Items.Clear;
end;

function TArray.Swap;
begin
   Result := false;
end;

procedure TArray._work_doSort;
var i:integer;
    fl:boolean;
    p:cardinal;
begin
   if Items.Count > 1 then
    repeat
     fl := false;
     for i := 0 to Items.Count-2 do
      if Swap(Items.Objects[i],Items.Objects[i+1]) then
        begin
         p := Items.Objects[i];
         Items.Objects[i] := Items.Objects[i+1];
         Items.Objects[i+1] := p;
         fl := true;
        end;
    until not fl;
end;

procedure TArray.SetItems;
begin
   Items.Free;
   Items := Value;
end;

procedure TArray._var_Array;
begin
   dtArray(_data,@Arr);
end;

procedure TArray._var_Count;
begin
   dtInteger(_data,Items.Count);
end;

function TArray.DataToPointer;
begin
  Result := 0;
end;

procedure TArray.PointerToData;
begin
   dtNull(Result);
end;


procedure TArray.Delete;
begin
end;

procedure TArray.Add;
begin
   Items.Add('');
   Items.Objects[Items.Count-1] := DataToPointer(Val);
end;

procedure TArray.Write;
var i:integer;
    s:string;
    dt:TData;
begin
   if Items.Count > 0 then
    begin
     if _prop_UseName then
      begin
        dt := Item;
        s := ToString(Item);
        Item := dt;
        for i := 0 to Items.Count-1 do
         if Items.Items[i] = s then
          begin
            Delete(Items.Objects[i]);
            Items.Objects[i] := DataToPointer(Val);
            Exit;
          end;
      end;
     i := ToIntIndex(Item);
     if(i >= 0)and(i < Items.Count) then
      begin
       Delete(Items.Objects[i]);
       Items.Objects[i] := DataToPointer(Val);
      end;
    end;
end;

function TArray.Read;
var i:integer;
    s:string;
    dt:TData;
begin
   Val.Data_type := data_null;
   if Items.Count > 0 then
    begin
     if _prop_UseName then
      begin
        dt := Item;
        s := ToString(Item);
        Item := dt;
        for i := 0 to Items.Count-1 do
         if Items.Items[i] = s then
          begin
           PointerToData(Items.Objects[i],Val);
           Result := val.Data_type <> data_null;
           Exit;
          end;
      end;
     i := ToIntIndex(Item);
     if(i >= 0)and(i < Items.Count) then
       PointerToData(Items.Objects[i],Val);
    end;

  Result := val.Data_type <> data_null;
end;

function TArray.Count;
begin
   Result := Items.Count;
end;

function MakeArrayInteger;
var i:integer;
begin
   //_debug(Names);
   Result := NewStrListEx;
   Result.Text := Names;
   for i := 0 to Result.Count-1 do
     Result.Objects[i] := Values[i];
end;

function MakeArrayBitmap;
begin
   Result := MakeArrayInteger(Names,Values);
end;

function MakeArrayReal;
var i:integer;
    r:^real;
begin
   Result := NewStrListEx;
   Result.Text := Names;
   for i := 0 to Result.Count-1 do
    begin
     new(r);
     r^ := Values[i];
     Result.Objects[i] := cardinal(r);
    end;
end;

function MakeArrayWave;
var i:integer;
    r:^string;
begin
   Result := NewStrListEx;
   Result.Text := Names;
   for i := 0 to Result.Count-1 do
    begin
     new(r);
     cardinal(r^) := 0;
     r^ := Values[i];
     Result.Objects[i] := cardinal(r);
    end;
end;

//___________________

procedure AddMTData(p,q:PData; var forFree:PData);
begin
  if p.data_type <> data_null then
    while p.ldata <> nil do
      p := p.ldata
  else begin
    p^ := q^;
    q := q.ldata;
    p.ldata := nil;
  end;
  forFree := p;
  while(q <> nil)and(q.data_type <> data_null) do begin
    new(p.ldata);
    p := p.ldata;
    p^ := q^;
    q := q.ldata;
  end;
end;

procedure FreeData(Data:PData);
var k:PData;
begin
   {$ifdef MT_ENABLED}
   k := Data.ldata;
   Data.ldata := nil;
   while k <> nil do
    begin
      Data := k;
      k := k.ldata;
      dispose(Data);
    end;
   {$endif}
end;

procedure CopyData(Dest,Src:PData);
begin
   Dest^ := Src^;
   {$ifdef MT_ENABLED}
   while (Src.data_type<>data_null)and(Src.ldata <> nil) do
    begin
       Src := Src.ldata;
       new(Dest.ldata);
       Dest := Dest.ldata;
       Dest^ := Src^;
    end;
   {$endif}
end;

//___________________

function ToIntIndex;
begin
   case _isType(Data) of
    data_int : Result := data.idata;
    data_real: Result := round(data.rdata);
    data_str: begin
      Result := str2int(Data.sdata);
      if (Data.sdata = '')or(Result = 0)and(data.sdata[1] <> '0')then
        Result := -1;
    end;
    else Result := -1;
   end;
   //Data.data_type := data_null;
end;

procedure TArr_nil._Set;
begin
end;

procedure TArr_nil._Add;
begin
end;

function CreateArray;
begin
  new(Result);
  Result._Get := _Get;
  Result._Count := _Count;
  if not Assigned(_Set) then
    Result._Set := _arr._Set
  else Result._Set := _Set;
  if not Assigned(_Add) then
    Result._Add := _arr._Add
  else Result._Add := _Add;
end;

function CreateMatrix;
begin
   new(result);
   Result._Get := _Get;
   Result._Set := _Set;
   Result._Rows := _Y;
   Result._Cols := _X;
end;

{$ifdef F_P}
type TMTh = class(PThread);

function ThreadFunc(Thread: PThread): integer; stdcall;
begin
  Result := Thread.Execute;
end;

function NewThreadForFPC:PTHread;
begin
   Result := PTHread.Create;
   TMTh(Result).FHandle := CreateThread( nil, // no security
                                  0,   // the same stack size
                                  @ThreadFunc, // thread entry point
                                  Result,      // parameter to pass to ThreadFunc
                                  CREATE_SUSPENDED,   // always SUSPENDED
                                  TMTh(Result).FThreadID ); // receive thread ID
end;
{$endif}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ GRAFICS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function GetRGB(const Color: TColor): TRGB;
var
  iColor: TColor;
begin
  iColor := Color2RGB(Color);
  Result.R := GetRValue(iColor);
  Result.G := GetGValue(iColor);
  Result.B := GetBValue(iColor);
end;

function GetLightColor(Color: TColor; Light: Byte) : TColor;
var
  fFrom: TRGB;
begin
  FFrom := GetRGB(Color);
  Result := RGB(
    Round(FFrom.R + (255 - FFrom.R) * (Light / 100)),
    Round(FFrom.G + (255 - FFrom.G) * (Light / 100)),
    Round(FFrom.B + (255 - FFrom.B) * (Light / 100))
  );
end;

function GetShadeColor(Color: TColor; Shade: Byte) : TColor;
var
  fFrom: TRGB;
begin
  FFrom := GetRGB(Color);
  Result := RGB(
    Max(0, FFrom.R - Shade),
    Max(0, FFrom.G - Shade),
    Max(0, FFrom.B - Shade)
  );
end;

procedure _Polyline(DC: HDC;const Points: array of TPoint);
begin
  Polyline(DC, PPoints(@Points)^, High(Points) + 1);
end;

procedure _Gradient(Sender:PControl; DC:HDC; cbRect:TRect; Gradient:boolean; DepthGradient:integer; LightColor,DarkColor,ColorFrame:TColor; Frame,Horizontal,InversGrad:boolean);
var   dr,dg,db:byte;
      _Color,ColorLight,lj,dj:TColor;
      t:real;
      j:integer;
begin
   with Sender{$ifndef F_P}^{$endif} do begin
         Canvas.Brush.Color:= Color2RGB(ColorFrame);
         if Frame then FillRect(DC,cbRect,Canvas.Brush.Handle);
         if Gradient then begin
            ColorLight:= GetLightColor(LightColor, DepthGradient);
            lj := ToSysColor(ColorLight);
            dj := ToSysColor(DarkColor);
            dr := TRGB(lj).r - TRGB(dj).r;
            dg := TRGB(lj).g - TRGB(dj).g;
            db := TRGB(lj).b - TRGB(dj).b;
            if Frame and not Horizontal then
               for j := 0 to (cbRect.Bottom - cbRect.Top - 3) do begin
                  if InversGrad then
                     t := ((max(cbRect.Bottom - cbRect.Top - 2,2) - 1) - j)/(max(cbRect.Bottom - cbRect.Top - 2,2) - 1)
                  else
                     t := j/(max(cbRect.Bottom - cbRect.Top - 2,2) - 1);
                  with TRGB(dj) do _Color := RGB(Round(dr*t + r),Round(dg*t + g),Round(db*t + b));
                  Canvas.Pen.Color := _Color;
                  SelectObject(DC,Canvas.Pen.Handle);
                  _Polyline(DC,[MakePoint(cbRect.Left+1,  cbRect.Bottom - j - 2),
                             MakePoint(cbRect.Right-1, cbRect.Bottom - j - 2)])
               end
            else if not Frame and not Horizontal then
               for j := 1 to (cbRect.Bottom - cbRect.Top) do begin
                  if InversGrad then
                     t := ((max(cbRect.Bottom - cbRect.Top, 1)) - j)/(max(cbRect.Bottom - cbRect.Top, 1))
                  else
                     t := j/(max(cbRect.Bottom - cbRect.Top, 1));
                  with TRGB(dj) do _Color := RGB(Round(dr*t + r),Round(dg*t + g),Round(db*t + b));
                  Canvas.Pen.Color := _Color;
                  SelectObject(DC,Canvas.Pen.Handle);
                  _Polyline(DC,[MakePoint(cbRect.Left,  cbRect.Bottom - j),
                             MakePoint(cbRect.Right, cbRect.Bottom - j)]);
               end
            else if Frame and Horizontal then
               for j := 0 to (cbRect.Right - cbRect.Left - 3) do begin
                  if InversGrad then
                     t := ((max(cbRect.Right - cbRect.Left - 2, 2)) - j)/(max(cbRect.Right - cbRect.Left - 2, 2))
                  else
                     t := j/(max(cbRect.Right - cbRect.Left - 2, 2));
                  with TRGB(dj) do _Color := RGB(Round(dr*t + r),Round(dg*t + g),Round(db*t + b));
                  Canvas.Pen.Color := _Color;
                  SelectObject(DC,Canvas.Pen.Handle);
                  _Polyline(DC,[MakePoint(cbRect.Right -  j - 2,  cbRect.Bottom - 2),
                             MakePoint(cbRect.Right -  j - 2, cbRect.Top)]);
               end
            else if not Frame and Horizontal then
               for j := 0 to (cbRect.Right - cbRect.Left) do begin
                  if InversGrad then
                     t := ((max(cbRect.Right - cbRect.Left, 1)) - j)/(max(cbRect.Right - cbRect.Left, 1))
                  else
                     t := j/(max(cbRect.Right - cbRect.Left, 1));
                  with TRGB(dj) do _Color := RGB(Round(dr*t + r),Round(dg*t + g),Round(db*t + b));
                  Canvas.Pen.Color := _Color;
                  SelectObject(DC,Canvas.Pen.Handle);
                  _Polyline(DC,[MakePoint(cbRect.Right -  j,  cbRect.Bottom - 1),
                             MakePoint(cbRect.Right -  j, cbRect.Top - 1)]);
               end;
         end
         else begin
            Canvas.Brush.Color:= GetLightColor(DarkColor, 40);
            if Frame then
               FillRect(DC,MakeRect(cbRect.Left+1,cbRect.Top+1,cbRect.Right-1,cbRect.Bottom-1), Canvas.Brush.Handle)
            else
               FillRect(DC,cbRect,Canvas.Brush.Handle)
         end;
   end;
end;

end.